/* windows.h*/
/*
 * Copyright (c) 1999 Greg Haerr <greg@censoft.com>
 *
 * Micro-Win Win32 API master header file
 */
#include "device.h"
#include "list.h"
#include "windef.h"
#include "wingdi.h"
#include "winuser.h"
#include "winctl.h"

/* internal stuff for now*/
/* winuser.c*/
extern int	SYSMETRICS_CYCAPTION;

/* external routines*/
int WINAPI 	WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
    			LPSTR lpCmdLine, int nShowCmd);

/* Internal Micro-Win non-win32 definitions*/

/* device context*/
struct hdc {
	HWND		hwnd;		/* associated window*/
	BOOL		bClientDC;	/* true if client DC*/
	int		bkmode;		/* background mode*/
	COLORVAL	bkcolor;	/* text background color*/
	COLORVAL	textcolor;	/* text color*/
	HBRUSH		brush;		/* current brush*/
	HPEN		pen;		/* current pen*/
	HFONT		font;		/* current font*/
	POINT		pt;		/* current pen pos in client coords*/

	MODE		mode;		/* drawing mode */
};

/* cursor*/
struct hcursor {
	int		usecount;	/* use counter */
	SWCURSOR	cursor;		/* software cursor definition*/
};

/* window*/
struct hwnd {
	RECT		winrect;	/* window rect in screen coords*/
	RECT		clirect;	/* client rect in screen coords*/
	DWORD		style;		/* window style*/
	DWORD		exstyle;	/* window extended style*/
	PWNDCLASS	pClass;		/* window class*/
	struct hwnd	*parent;	/* parent window */
	struct hwnd	*children;	/* first child window */
	struct hwnd	*siblings;	/* next sibling window */
	struct hwnd	*next;		/* next window in complete list */
	struct hcursor	*cursor;	/* cursor for this window */
	int		unmapcount;	/* count of reasons not really mapped */
	int		id;		/* window id */
	CHAR		szTitle[64];	/* window title*/
	int		gotPaintMsg;	/* window had WM_PAINT PostMessage*/
	int		nextrabytes;	/* # window extra bytes*/

	char		extrabytes[1];	/* window extra bytes - must be last*/
};

/* gotPaintMsg values*/
#define PAINT_PAINTED		0	/* WM_PAINT msg has been processed*/
#define PAINT_NEEDSPAINT	1	/* WM_PAINT seen, paint when can*/
#define PAINT_DELAYPAINT	2	/* WM_PAINT seen,paint after user move*/

/* gdiobj*/
struct hgdiobj {
	int		type;		/* object type*/
	int		style;		/* object style*/
	COLORREF	color;		/* object color*/
	BOOL		stockobj;	/* stock object or not*/
};
