/* wintern.h*/
/*
 * Copyright (c) 1999 Greg Haerr <greg@censoft.com>
 *
 * Micro-Win internal routines header file
 */
#if UNIX
#define strcmpi	strcasecmp
#endif

/* non-win32 api access for microwin*/
BOOL		WndSetDesktopWallpaper(PIMAGEHDR pImage);

/* internal routines*/

/* winuser.c*/
PWNDCLASS 	WndFindClassByName(LPCSTR lpClassName);
void		WndDestroyWindow(HWND hwnd,BOOL bSendMsg);
HWND		WndGetTopWindow(HWND hwnd);
void		WndCalcClientRect(HWND hwnd, DWORD dwStyle);
void		WndSendSizeMove(HWND hwnd, BOOL bSize, BOOL bMove);
void		WndSetCursor(HWND wp, PSWCURSOR pcursor);

/* wingdi.c*/
#define WndIsClientDC(hdc)	((hdc)->bClientDC)
HWND		WndPrepareDC(HDC hdc);
void		WndSetClipWindow(HDC hdc);

/* winexpos.c*/
void		WndRedrawScreen(void);
void		WndHideWindow(HWND hwnd,BOOL bChangeFocus);
void		WndShowWindow(HWND hwnd);
void		WndRaiseWindow(HWND hwnd);
void		WndLowerWindow(HWND hwnd);
BOOL		WndCheckOverlap(HWND topwp, HWND botwp);
void		WndClearWindow(HWND wp,COORD x,COORD y,COORD width,COORD height,
			BOOL exposeflag);
void		WndExposeArea(HWND wp, COORD rootx,COORD rooty,COORD width,
			COORD height);
/* winevent.c*/
void		GsCheckMouseEvent(void);
void		GsCheckKeyboardEvent(void);
void 		GsHandleMouseStatus(COORD newx, COORD newy, BUTTON newbuttons);
void		GsDeliverButtonEvent(BUTTON buttons, BUTTON changebuttons,
			MODIFIER modifiers);
void		GsDeliverMotionEvent(BUTTON buttons, MODIFIER modifiers);
void		GsDeliverKeyboardEvent(UCHAR ch, MODIFIER modifiers);
void		GsDeliverExposureEvent(HWND wp, COORD x, COORD y, COORD width,
			COORD height);
void		GsMoveCursor(COORD x, COORD y);
void		GsCheckCursor(void);
HWND		WndFindVisibleWindow(COORD x, COORD y);
void		GsCheckMouseWindow(void);
int		strzcpy(char *dst,const char *src,int dstsiz);

/* winmain.c*/
int		GsOpen(void);
void		GsClose(void);
void		GsSelect(void);
int		GsInitialize(void);
void		GsTerminate(void);
extern	HWND	listwp;			/* list of all windows */
extern	HWND	rootwp;			/* root window pointer */
extern	HWND	focuswp;		/* focus window for keyboard */
extern	HWND	mousewp;		/* window mouse is currently in */
extern	HWND	capturewp;		/* capture window*/
extern  HWND	dragwp;			/* window user is dragging*/
extern	HCURSOR	curcursor;		/* currently enabled cursor */
extern	COORD	cursorx;		/* x position of cursor */
extern	COORD	cursory;		/* y position of cursor */
extern	SCREENINFO	sinfo;		/* screen information */

#if BOGL
/* temp bogl library stuff at upper level
 * the bogl library should handle all this at the lower
 * level, just like vgalib does.
 */
void bogl_InitVt(void);
int  bogl_CurrentVt(void);
int  bogl_CheckVtChange(void);
void bogl_RedrawVt(int t);
extern int vterm;
#endif /* BOGL*/
